<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">

<head>

<meta charset="utf-8" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="generator" content="pandoc" />


<meta name="author" content="Monica Abrudan" />

<meta name="date" content="2020-12-10" />

<title>Kpn AMR Phenotype - Genotypic prediction concordance analysis</title>

<script src="site_libs/jquery-1.11.3/jquery.min.js"></script>
<meta name="viewport" content="width=device-width, initial-scale=1" />
<link href="site_libs/bootstrap-3.3.5/css/bootstrap.min.css" rel="stylesheet" />
<script src="site_libs/bootstrap-3.3.5/js/bootstrap.min.js"></script>
<script src="site_libs/bootstrap-3.3.5/shim/html5shiv.min.js"></script>
<script src="site_libs/bootstrap-3.3.5/shim/respond.min.js"></script>
<script src="site_libs/navigation-1.1/tabsets.js"></script>
<link href="site_libs/highlightjs-9.12.0/default.css" rel="stylesheet" />
<script src="site_libs/highlightjs-9.12.0/highlight.js"></script>

<style type="text/css">code{white-space: pre;}</style>
<style type="text/css">
  pre:not([class]) {
    background-color: white;
  }
</style>
<script type="text/javascript">
if (window.hljs) {
  hljs.configure({languages: []});
  hljs.initHighlightingOnLoad();
  if (document.readyState && document.readyState === "complete") {
    window.setTimeout(function() { hljs.initHighlighting(); }, 0);
  }
}
</script>



<style type="text/css">
h1 {
  font-size: 34px;
}
h1.title {
  font-size: 38px;
}
h2 {
  font-size: 30px;
}
h3 {
  font-size: 24px;
}
h4 {
  font-size: 18px;
}
h5 {
  font-size: 16px;
}
h6 {
  font-size: 12px;
}
.table th:not([align]) {
  text-align: left;
}
</style>




<style type = "text/css">
.main-container {
  max-width: 940px;
  margin-left: auto;
  margin-right: auto;
}
code {
  color: inherit;
  background-color: rgba(0, 0, 0, 0.04);
}
img {
  max-width:100%;
  height: auto;
}
.tabbed-pane {
  padding-top: 12px;
}
.html-widget {
  margin-bottom: 20px;
}
button.code-folding-btn:focus {
  outline: none;
}
summary {
  display: list-item;
}
</style>


<style type="text/css">
/* padding for bootstrap navbar */
body {
  padding-top: 51px;
  padding-bottom: 40px;
}
/* offset scroll position for anchor links (for fixed navbar)  */
.section h1 {
  padding-top: 56px;
  margin-top: -56px;
}
.section h2 {
  padding-top: 56px;
  margin-top: -56px;
}
.section h3 {
  padding-top: 56px;
  margin-top: -56px;
}
.section h4 {
  padding-top: 56px;
  margin-top: -56px;
}
.section h5 {
  padding-top: 56px;
  margin-top: -56px;
}
.section h6 {
  padding-top: 56px;
  margin-top: -56px;
}
.dropdown-submenu {
  position: relative;
}
.dropdown-submenu>.dropdown-menu {
  top: 0;
  left: 100%;
  margin-top: -6px;
  margin-left: -1px;
  border-radius: 0 6px 6px 6px;
}
.dropdown-submenu:hover>.dropdown-menu {
  display: block;
}
.dropdown-submenu>a:after {
  display: block;
  content: " ";
  float: right;
  width: 0;
  height: 0;
  border-color: transparent;
  border-style: solid;
  border-width: 5px 0 5px 5px;
  border-left-color: #cccccc;
  margin-top: 5px;
  margin-right: -10px;
}
.dropdown-submenu:hover>a:after {
  border-left-color: #ffffff;
}
.dropdown-submenu.pull-left {
  float: none;
}
.dropdown-submenu.pull-left>.dropdown-menu {
  left: -100%;
  margin-left: 10px;
  border-radius: 6px 0 6px 6px;
}
</style>

<script>
// manage active state of menu based on current page
$(document).ready(function () {
  // active menu anchor
  href = window.location.pathname
  href = href.substr(href.lastIndexOf('/') + 1)
  if (href === "")
    href = "index.html";
  var menuAnchor = $('a[href="' + href + '"]');

  // mark it active
  menuAnchor.parent().addClass('active');

  // if it's got a parent navbar menu mark it active as well
  menuAnchor.closest('li.dropdown').addClass('active');
});
</script>

<!-- tabsets -->

<style type="text/css">
.tabset-dropdown > .nav-tabs {
  display: inline-table;
  max-height: 500px;
  min-height: 44px;
  overflow-y: auto;
  background: white;
  border: 1px solid #ddd;
  border-radius: 4px;
}

.tabset-dropdown > .nav-tabs > li.active:before {
  content: "";
  font-family: 'Glyphicons Halflings';
  display: inline-block;
  padding: 10px;
  border-right: 1px solid #ddd;
}

.tabset-dropdown > .nav-tabs.nav-tabs-open > li.active:before {
  content: "&#xe258;";
  border: none;
}

.tabset-dropdown > .nav-tabs.nav-tabs-open:before {
  content: "";
  font-family: 'Glyphicons Halflings';
  display: inline-block;
  padding: 10px;
  border-right: 1px solid #ddd;
}

.tabset-dropdown > .nav-tabs > li.active {
  display: block;
}

.tabset-dropdown > .nav-tabs > li > a,
.tabset-dropdown > .nav-tabs > li > a:focus,
.tabset-dropdown > .nav-tabs > li > a:hover {
  border: none;
  display: inline-block;
  border-radius: 4px;
}

.tabset-dropdown > .nav-tabs.nav-tabs-open > li {
  display: block;
  float: none;
}

.tabset-dropdown > .nav-tabs > li {
  display: none;
}
</style>

<script>
$(document).ready(function () {
  window.buildTabsets("TOC");
});

$(document).ready(function () {
  $('.tabset-dropdown > .nav-tabs > li').click(function () {
    $(this).parent().toggleClass('nav-tabs-open')
  });
});
</script>

<!-- code folding -->




</head>

<body>


<div class="container-fluid main-container">




<div class="navbar navbar-default  navbar-fixed-top" role="navigation">
  <div class="container">
    <div class="navbar-header">
      <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#navbar">
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
      </button>
      <a class="navbar-brand" href="index.html">R examples</a>
    </div>
    <div id="navbar" class="navbar-collapse collapse">
      <ul class="nav navbar-nav">
        <li>
  <a href="data_joining_2.html">Refining/merging data from Pathogen Watch</a>
</li>
<li>
  <a href="plot_AMR_profiles_per_ST.html">Plot AMR profiles</a>
</li>
<li>
  <a href="data_joining_1.html">Manipulating AMR metadata</a>
</li>
<li>
  <a href="Kpn_concordance_analysis.html">Kpn pathogen watch concordance</a>
</li>
      </ul>
      <ul class="nav navbar-nav navbar-right">
        
      </ul>
    </div><!--/.nav-collapse -->
  </div><!--/.container -->
</div><!--/.navbar -->

<div class="fluid-row" id="header">



<h1 class="title toc-ignore">Kpn AMR Phenotype - Genotypic prediction concordance analysis</h1>
<h4 class="author">Monica Abrudan</h4>
<h4 class="date">12/10/2020</h4>

</div>


<p>This code generates TP, TN, FP, FN values with associated confidence intervals. The input for the AMR phenotype is read from the profile.csv file generated by Pathogen.watch. The input for the AMR genotype is a WHONET interpretation of Vitek files.</p>
<pre class="r"><code>require(dplyr)
require(epiR)</code></pre>
<p>Read in Whonet interpretations of MIC data</p>
<pre class="r"><code>path&lt;-&quot;data/Knp_concordance_analysis/&quot;
ast&lt;-read.csv(file=paste(path, &quot;whonet_interpretation.tsv&quot;,sep=&quot;&quot;), sep=&quot;\t&quot;)
head(ast, n = 1L)</code></pre>
<pre><code>##   Country Laboratory Origin Identification.number Last.name First.name Sex Date.of.birth Age Age.category Location Institution Department
## 1     COL        RET     NA             G18000655        NA         NA  NA            NA  NA           NA       NA          NA         NA
##   Location.type Date.of.admission Specimen.number Specimen.date Specimen.type Local.specimen.code Specimen.type..Numeric. Reason Isolate.number
## 1            NA                NA                            NA            NA                  NA                      NA     NA             NA
##   Organism Local.organism.code Organism.type Serotype MRSA VRE Beta.lactamase ESBL Carbapenemase MRSA.screening.test
## 1      aba                 aba             -       NA   NA  NA             NA   NA            NA                  NA
##   Inducible.clindamycin.resistance Comment Date.of.data.entry AMC AMK AMP ATM AZM CAZ CEP CFM CHL CIP CLI COL COP CRO CSL CTX CXA CXM CZO DAP DOR
## 1                               NA      NA          30/9/2020                       R               R      S?       R                           R
##   ENR ERY ETP FEP FOX GEN IPM LNZ LVX MAN MEM MFX MNO NAL NOR NTZ OFX OXA PEN PIP QDA RIF SAM SPT STR SXT TCC TCY TEC TGC TOB TZP VAN  X
## 1               R       R   R               R                                               R                                   R     NA</code></pre>
<p>The set of potential phenotypes reported in the WHONET AST file is [I R S S? R? NS]. These need converting to R or S values only.</p>
<pre class="r"><code>ast[] &lt;- lapply(ast, as.character)
ast[ast == &quot;S?&quot;] &lt;- &quot;S&quot;
ast[ast == &quot;R?&quot;] &lt;- &quot;R&quot;
ast[ast == &quot;I&quot;] &lt;- &quot;R&quot;
ast[ast == &quot;NS&quot;] &lt;- &quot;R&quot;</code></pre>
<p>Read in profile data from Pathogenwatch</p>
<pre class="r"><code>profile &lt;- read.csv(file=paste(path, &quot;profile.csv&quot;, sep=&quot;&quot;), sep=&quot;,&quot;)
#Colistin appears as COL in AST file and as CST in the profile.csv file. 
colnames(profile)[6] &lt;- &quot;COL&quot;
head(profile, n = 1L)</code></pre>
<pre><code>##        NAME MEM CRO CAZ FEP COL
## 1 G18763376   0   1   1   1   0</code></pre>
<p>Select only AST data for which genotypic predictions exist in the profile.csv file.</p>
<pre class="r"><code>ast_selected &lt;- subset(ast, (ast$Identification.number %in% profile$NAME))</code></pre>
<p>Set up a matrix with TP, FN, FP and TN count data. Each row corresponds to an antibiotic. The columns represent: TP (Resistant phenotype, Resistant genotypic prediction), FN (Resistant phenotype, Sensitive genotypic prediction), FP (Sensitive phenotype, Resistant genotypic prediction) and TN (Sensitive phenotype, Sensitive genotypic prediction)</p>
<pre class="r"><code>results &lt;- matrix(nrow=0, ncol=4)
colnames(results) &lt;- c(&quot;TP&quot;,&quot;FN&quot;,&quot;FP&quot;,&quot;TN&quot;)
for (i in 2:ncol(profile)){
  results &lt;-rbind(results,0)
  rownames(results)[i-1] &lt;- colnames(profile)[i]
}</code></pre>
<p>Save the names of samples which give FP or FN results.</p>
<pre class="r"><code>results_sample_FP_FN &lt;- matrix(nrow=0, ncol=3)
colnames(results_sample_FP_FN) &lt;- c(&quot;Sample&quot;,&quot;Antibiotic&quot;,&quot;FP/FN&quot;)</code></pre>
<p>Compute the values corresponding for each antibiotic.</p>
<pre class="r"><code>for (i in 1:nrow(profile)){
  for (j in 2:ncol(profile)){
    antibiotic &lt;- colnames(profile)[j]
    sampleName &lt;- as.character(profile[i,1])
    #Identify the phenotype in the AST file, corresponding to the Antibiotic antibiotic in the genotypic prediction file.
    colNo &lt;- which( colnames(ast_selected)== antibiotic)
    phenotype &lt;- as.character(ast_selected[ast_selected$Identification.number==sampleName,colNo])
    if (! (is.null (ast_selected[sampleName,antibiotic]))) {
      if ( (length(phenotype)&gt;0) &amp;&amp; (! (phenotype==&quot;&quot;)) ){
        #Select only Sample-Antibiotic combos which have both phenotypic data and genotypic prediction results.
        
        #Select the corresponding row number in the results table.
        rowNo &lt;- which(rownames(results)== antibiotic)
        
        if ( (profile[i,j] == &quot;0&quot;) &amp;&amp; (phenotype == &quot;S&quot;)) {
          results[rowNo,&quot;TN&quot;] &lt;- results[rowNo,&quot;TN&quot;] + 1
        }
        if ( (profile[i,j] == &quot;0&quot;) &amp;&amp; (phenotype == &quot;R&quot;)) {
          results[rowNo,&quot;FN&quot;] &lt;- results[rowNo,&quot;FN&quot;] + 1
          results_sample_FP_FN &lt;- rbind (results_sample_FP_FN, c(sampleName, antibiotic, &quot;FN&quot;))
        }
        if ( (profile[i,j] == &quot;1&quot;) &amp;&amp; (phenotype == &quot;R&quot;)) {
          results[rowNo,&quot;TP&quot;] &lt;- results[rowNo,&quot;TP&quot;] + 1
        }
        if ( (profile[i,j] == &quot;1&quot;) &amp;&amp; (phenotype == &quot;S&quot;)) {
          results[rowNo,&quot;FP&quot;] &lt;- results[rowNo,&quot;FP&quot;] + 1
          results_sample_FP_FN &lt;- rbind (results_sample_FP_FN, c(sampleName, antibiotic, &quot;FP&quot;))
        }
      }
    }
  }  
}
head(results)</code></pre>
<pre><code>##      TP FN  FP  TN
## MEM 596 65  30 160
## CRO 901 23  63   0
## CAZ 472 23  72   0
## FEP 717 17 241   6
## COL   0 44   0 253</code></pre>
<pre class="r"><code>reported_results &lt;- matrix (nrow=0, ncol=7)
colnames(reported_results) &lt;- c(&quot;Total # isolates tested&quot;, &quot;TP&quot;, &quot;FN&quot;, &quot;FP&quot;, &quot;TN&quot;, &quot;sensitivity&quot;, &quot;specificity&quot;)
noRows&lt;-0
for (i in 1:nrow(results)){
  if (sum(results[i,]) &gt; 0 ){
    PhePosGenoPos &lt;- results[i,1]
    PhePosGenoMin &lt;- results[i,2]
    PheMinGenoPos &lt;- results[i,3]
    PheMinGenoMin &lt;- results[i,4]
    
    dat &lt;- as.table(matrix(c(PhePosGenoPos,PheMinGenoPos,PhePosGenoMin,PheMinGenoMin), nrow = 2, byrow = TRUE))
    colnames(dat) &lt;- c(&quot;Phe+&quot;,&quot;Phe-&quot;)
    rownames(dat) &lt;- c(&quot;Geno+&quot;,&quot;Geno-&quot;)
    rval &lt;- epi.tests(dat, conf.level = 0.95)
    total &lt;- sum (results[i,])
    sensitivity &lt;- round (rval$elements$se, digits=2)
    specificity &lt;- round (rval$elements$sp, digits=2)
    #print(rval); summary(rval)
    
    a&lt;- c(total, PhePosGenoPos, PhePosGenoMin, PheMinGenoPos, PheMinGenoMin, sensitivity, specificity)
    reported_results &lt;- rbind(reported_results, a)
    noRows &lt;- noRows +1
    row.names(reported_results)[noRows] &lt;- rownames(results)[i]
  }
}
reported_results</code></pre>
<pre><code>##     Total # isolates tested  TP FN  FP  TN sensitivity specificity
## MEM                     851 596 65  30 160        0.90        0.84
## CRO                     987 901 23  63   0        0.98        0.00
## CAZ                     567 472 23  72   0        0.95        0.00
## FEP                     981 717 17 241   6        0.98        0.02
## COL                     297   0 44   0 253        0.00        1.00</code></pre>
<p>List of samples with FP/FN status</p>
<pre class="r"><code>head(results_sample_FP_FN)</code></pre>
<pre><code>##      Sample      Antibiotic FP/FN
## [1,] &quot;G18763376&quot; &quot;CAZ&quot;      &quot;FP&quot; 
## [2,] &quot;G18763376&quot; &quot;FEP&quot;      &quot;FP&quot; 
## [3,] &quot;G18255255&quot; &quot;MEM&quot;      &quot;FP&quot; 
## [4,] &quot;G18255255&quot; &quot;CRO&quot;      &quot;FP&quot; 
## [5,] &quot;G18255255&quot; &quot;FEP&quot;      &quot;FP&quot; 
## [6,] &quot;G18000749&quot; &quot;CAZ&quot;      &quot;FP&quot;</code></pre>




</div>

<script>

// add bootstrap table styles to pandoc tables
function bootstrapStylePandocTables() {
  $('tr.header').parent('thead').parent('table').addClass('table table-condensed');
}
$(document).ready(function () {
  bootstrapStylePandocTables();
});


</script>

<!-- dynamically load mathjax for compatibility with self-contained -->
<script>
  (function () {
    var script = document.createElement("script");
    script.type = "text/javascript";
    script.src  = "https://mathjax.rstudio.com/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML";
    document.getElementsByTagName("head")[0].appendChild(script);
  })();
</script>

</body>
</html>
